<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    exclude-result-prefixes="xs f"
    xmlns:f="http://oxygenxml.com/xslt/functions"
    version="2.0">

    
    
    <xd:doc xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl">
        <xd:desc>
            <xd:p>This function calculates the total price of the books.</xd:p>
        </xd:desc>
        <xd:param name="books">A sequence of book elements.</xd:param>
        <xd:return>The total price.</xd:return>
    </xd:doc>
    <xsl:function name="f:total">
        <xsl:param name="books"/>
        
        <xsl:value-of select="sum($books[1]/price/text())"/>
    </xsl:function>
    
    <div xmlns="http://www.w3.org/1999/xhtml">A documentation <b>in HTML format</b></div>
    <xsl:template name="printBookTitle">
        <xsl:param name="book"/>
        
        <div class="book.title">
            <h2><xsl:value-of select="$book/title"/></h2>
            <div>
                <span><xsl:value-of select="f:formatDate($book/date/text())"/></span>
                <span>written by <xsl:value-of select="$book/author"/></span>
            </div>
        </div>
    </xsl:template>
    
    <xsl:function name="f:formatDate">
        <xsl:param name="date"/>
        
        <xsl:value-of select="format-date($date,'[M]/[D]/[Y]')"/>
    </xsl:function>
    
    
    
    <xsl:template match="books" mode="outline">
        <ol>
            <xsl:apply-templates mode="outline"/>
        </ol>
    </xsl:template>
    
    <xsl:template match="book" mode="outline">
        <li><xsl:value-of select="title"/></li>
    </xsl:template>

</xsl:stylesheet>